//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern double Period1 =  32;
extern double Period2 =   5;
extern double Period3 =  10;

double cmi[];
double cmihuu[];
double cmihud[];
double cmihdd[];
double cmihdu[];
double signal[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,cmihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,cmihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,cmihdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,cmihdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,cmi);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
      IndicatorShortName("Blau candlestick momentum index ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i)-iMA(NULL,0,1,0,MODE_SMA,PRICE_OPEN,i);
         double avg = iSsm(iSsm(        priceDiff ,Period1,i,0),Period2,i,1);
         double ava = iSsm(iSsm(MathAbs(priceDiff),Period1,i,2),Period2,i,3);
            if (ava != 0)
                  cmi[i] = 100.0*avg/ava;
            else  cmi[i] = 0;                  
            cmihuu[i] = EMPTY_VALUE;
            cmihud[i] = EMPTY_VALUE;
            cmihdd[i] = EMPTY_VALUE;
            cmihdu[i] = EMPTY_VALUE;
            signal[i] = iSsm(cmi[i],Period3,i,4);

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
               if (cmi[i] > cmi[i+1]) slope[i] =  1;
               if (cmi[i] < cmi[i+1]) slope[i] = -1;
               if (cmi[i]>0)
               if (slope[i]==1)
                     cmihuu[i] = cmi[i];
               else  cmihud[i] = cmi[i];
               if (cmi[i]<0)
               if (slope[i]==1)
                     cmihdu[i] = cmi[i];
               else  cmihdd[i] = cmi[i];
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSsm[][10];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo)
{
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
   return(workSsm[i][s+_ssm]);
}